/* --------------------------------------------------------------
         ( 1.2).

    http://www.imach.uran.ru/exarray

    Copyright 2001-2006, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#ifndef EXDEBUG_H
#define EXDEBUG_H

#ifndef EXARRAY_H
#include "Exarray.h"
#endif/*EXARRAY_H*/

/* --------------------------------------------------------------
    EXDEBUG(a)      -      
                          NDEBUG.
-------------------------------------------------------------- */

#ifndef NDEBUG
#define EXDEBUG(a)  ((void)(a))
#else /*NDEBUG*/
#define EXDEBUG(a)  ((void)0)
#endif/*NDEBUG*/

/* --------------------------------------------------------------
    EXARR(T,m,n)    -    m  n
                        T.  
                          m [n] 
                       ,    
                          .

    EXPTR(T)        -     
                       T.   
                        *   ,
                            
                       .

    EXPTRTO(T,m,n)  -    
                       m  n   T, 
                          
                      .    
                        ,  
                       .

    EXPTRTYPE(m)    -   
                       , 
                          ,
                        
                      .

    EXPTRBASE(p)    -    
                           
                         .

    EXPTRCHECK(p,n) -    
                       p    
                         
                        0..n-1.

    EXPTRINDEX(p,i) -    
                       p    
                         
                        0..i.

    EXPTRNEW(T,n)   -    
                       (. ALLOW_EXARRAY_NEW_DELETE),
                         
                       .

    EXPTRDELETE(p)  -    
                      ,   
                       .

    EXPTRALLOC(T,n) -    
                         
                      ,   .

    EXPTRFREE(p)    -  , 
                         .
                        .

    EXPTRALIGNED_ALLOC(T,n,a)   - EXPTRALLOC  .
    EXPTRALIGNED_FREE(T)        - EXPTRFREE  .

          
        NCHECKPTR  NDEBUG, 
        ,  .

    :              ( NCHECKPTR)         NCHECKPTR
    =================== ===========================     ===========
    EXARR(int,m,10);    int _m [10];                    int m [10];
                        exptr<int> p=exptr<int>(_m,10)
    EXPTR(int) p;       exptr<int> p;                   int* p;
    p = EXPTRTO(m,10);  p = exptr<int>(m,10);           p = m;
    EXPTRTYPE(m);       m;                              m.base();
    EXPTRBASE(p);       p.base();                       p;
-------------------------------------------------------------- */

#ifdef  NCHECKPTR

#define EXARR(T,m,n)    T m[(n)+1]
#define EXPTR(T)        T*
#define EXPTRTO(T,m,n)  (m)
#define EXPTRTYPE(m)    ((m).base())
#define EXPTRBASE(p)    (p)
#define EXPTRCHECK(p,n) (p)
#define EXPTRINDEX(p,i) (p)
#define EXPTRNEW(T,n)   (EXNEW(T,(n)))
#define EXPTRDELETE(p)  (EXDELETE(p))
#define EXPTRALLOC(T,n) (EXALLOC(T,(n)))
#define EXPTRFREE(p)    (EXFREE(p))
#define EXPTRALIGNED_ALLOC(T,n,a)   (EXALIGNED_ALLOC(T,(n),(a)))
#define EXPTRALIGNED_FREE(p)        (EXALIGNED_FREE(p))

#else /*NCHECKPTR*/

#define EXARR(T,m,n)    T m##___ [(n)+1];\
                        exptr<T>m = exptr<T>(m##___,\
                                      sizeof(m##___)/sizeof(T)-1,0)
#define EXPTR(T)        exptr<T>
#define EXPTRTO(T,m,n)  (exptr<T>((m),(n)))
#define EXPTRTYPE(m)    (m)
#define EXPTRBASE(p)    ((p).base())
#define EXPTRCHECK(p,n) ((p).check(n))
#define EXPTRINDEX(p,i) ((p).index(i))
#define EXPTRNEW(T,n)   (exptr<T>().allocate(n))
#define EXPTRDELETE(p)  ((p).deallocate())
#define EXPTRALLOC(T,n) (exptr<T>().alloc(n))
#define EXPTRFREE(p)    ((p).free())
#define EXPTRALIGNED_ALLOC(T,n,a)   (exptr<T>().aligned_alloc(n,a))
#define EXPTRALIGNED_FREE(p)        ((p).aligned_free())

#endif/*NCHECKPTR*/

#endif/*EXDEBUG_H*/
